Fix --fetchonly to actually work.
[catalyst.git] / targets / support / chroot-functions.sh
1
2 # Trap these signals and kill ourselves if recieved
3 # Force ourselves to die if any of these signals are recieved
4 # most likely our controlling terminal is gone
5 trap "echo SIGTERM signal recieved killing $0 with pid $$;kill -9 $$" SIGTERM
6 trap "echo SIGHUP signal recieved killing $0 with pid $$;kill -9 $$" SIGHUP
7 trap "echo SIGKILL signal recieved killing $0 with pid $$;kill -9 $$" SIGKILL
8
9 #SIGINT interrupt character (usually Ctrl-C)
10 #       * example: high-level sequence of events
11 #       * my process (call it "P") is running
12 #       * user types ctrl-c
13 #       * kernel recognizes this and generates SIGINT signal
14 trap "echo SIGINT signal recieved killing $0 with pid $$;kill -9 $$" SIGINT
15  
16 check_genkernel_version(){
17         if [ -x /usr/bin/genkernel ]
18         then
19                 genkernel_version=$(genkernel --version)
20                 genkernel_version_major=${genkernel_version%%.*}
21                 genkernel_version_minor_sub=${genkernel_version#${genkernel_version_major}.}
22                 genkernel_version_minor=${genkernel_version_minor_sub%%.*}
23                 genkernel_version_sub=${genkernel_version##*.}
24                 if [ -n "${genkernel_version}" -a "${genkernel_version_major}" -eq '3' -a "${genkernel_version_minor}" -ge '3' ]
25                 then
26                         echo "Genkernel version ${genkernel_version} found ... continuing"
27                 else
28                         echo "ERROR: Your genkernel version is too low in your seed stage.  genkernel version 3.3.0"
29                         echo "or greater is required."
30                         exit 1
31                 fi
32         else
33                 exit 1
34         fi
35 }
36
37 setup_myfeatures(){
38         if [ -n "${clst_CCACHE}" ]
39         then
40                 export clst_myfeatures="${clst_myfeatures} ccache"
41                 #if [ "${clst_AUTORESUME}" = "1" -a -e /tmp/.clst_ccache ]
42                 #then
43                 #       echo "CCACHE Autoresume point found not emerging ccache"
44                 #else
45                         emerge --oneshot --nodeps -b -k ccache || exit 1
46                 #       touch /tmp/.clst_ccache
47                 #fi
48         fi
49
50         if [ -n "${clst_DISTCC}" ]
51         then
52                 export clst_myfeatures="${clst_myfeatures} distcc"
53                 export DISTCC_HOSTS="${clst_distcc_hosts}"
54                 #if [ "${clst_AUTORESUME}" = "1" -a -e /tmp/.clst_distcc ]
55                 #then
56                 #       echo "DISTCC Autoresume point found not emerging distcc"
57                 #else
58                         USE="-gtk -gnome" emerge --oneshot --nodeps -b -k distcc || exit 1
59                         #touch /tmp/.clst_distcc
60                 #fi
61                 mkdir -p /etc/distcc
62                 echo "${clst_distcc_hosts}" > /etc/distcc/hosts
63         fi
64 }
65
66 setup_myemergeopts(){
67         if [ -n "${clst_PKGCACHE}" ]
68         then
69                 export clst_myemergeopts="--usepkg --buildpkg --newuse"
70                 export bootstrap_opts="-r"
71         fi
72         if [ -n "${clst_FETCH}" ]
73         then
74                 export bootstrap_opts="-f"
75                 export clst_myemergeopts="${clst_myemergeopts} -f"
76         fi
77 }
78
79
80 setup_portage(){
81         # portage needs to be merged manually with USE="build" set to avoid frying
82         # our make.conf. emerge system could merge it otherwise.
83         if [ "${clst_AUTORESUME}" = "1" -a -e /tmp/.clst_portage ]
84         then
85                 echo "Portage Autoresume point found not emerging portage"
86         else
87                 USE="build" run_emerge --oneshot --nodeps portage
88                 touch /tmp/.clst_portage || exit 1
89         fi
90 }
91
92 setup_gcc(){
93         if [ -x /usr/bin/gcc-config ]
94         then
95                 mythang=$( cd /etc/env.d/gcc; ls ${clst_CHOST}-* | head -n 1 )
96                 if [ -z "${mythang}" ]
97                 then
98                         mythang=1
99                 fi
100                 gcc-config ${mythang}; update_env_settings
101         fi
102 }
103
104 setup_binutils(){
105         if [ -x /usr/bin/binutils-config ]
106         then
107                 mythang=$( cd /etc/env.d/binutils; ls ${clst_CHOST}-* | head -n 1 )
108                 if [ -z "${mythang}" ]
109                 then
110                         mythang=1
111                 fi
112                 binutils-config ${mythang}; update_env_settings
113         fi
114 }
115
116 cleanup_distcc() {
117         rm -rf /etc/distcc/hosts
118 }
119
120 update_env_settings(){
121         /usr/sbin/env-update
122         source /etc/profile
123         [ -f /tmp/envscript ] && source /tmp/envscript
124 }
125
126 die() {
127         echo "$1"
128         exit 1
129 }
130
131 make_destpath() {
132         if  [ "${1}" = "" ]
133         then
134                 export ROOT=/
135         else
136                 export ROOT=${1}
137                 if [ ! -d ${ROOT} ]
138                 then
139                         install -d ${ROOT}
140                 fi
141         fi
142 }
143
144 run_emerge() {
145         # Sets up the ROOT= parameter
146         # with no options ROOT=/
147         make_destpath ${clst_root_path}
148         
149         export EMERGE_WARNING_DELAY=0   
150         export CLEAN_DELAY=0
151         export EBEEP_IGNORE=0
152         export EPAUSE_IGNORE=0
153         export CONFIG_PROTECT="-*"
154
155         if [ -n "${clst_VERBOSE}" ]
156         then
157                 echo "ROOT=${ROOT} emerge ${clst_myemergeopts} -vpt $@" || exit 1
158                 emerge ${clst_myemergeopts} -vpt $@ || exit 3
159                 echo "Press any key within 15 seconds to pause the build..."
160                 read -s -t 15 -n 1
161                 if [ $? -eq 0 ]
162                 then
163                         echo "Press any key to continue..."
164                         read -s -n 1
165                 fi
166         fi
167
168         echo "emerge ${clst_myemergeopts} $@" || exit 1
169
170         emerge ${clst_myemergeopts} $@ || exit 1
171 }
172
173 # Functions
174 # Copy libs of a executable in the chroot
175 function copy_libs() {
176         # Check if it's a dynamix exec
177         ldd ${1} > /dev/null 2>&1 || return
178
179         for lib in `ldd ${1} | awk '{ print $3 }'`
180         do
181                 echo ${lib}
182                 if [ -e ${lib} ]
183                 then
184                         if [ ! -e ${clst_root_path}/${lib} ]
185                         then
186                                 copy_file ${lib}
187                                 [ -e "${clst_root_path}/${lib}" ] && \
188                                 strip -R .comment -R .note ${clst_root_path}/${lib} \
189                                 || echo "WARNING : Cannot strip lib ${clst_root_path}/${lib} !"
190                         fi
191                 else
192                         echo "WARNING : Some library was not found for ${lib} !"
193                 fi
194         done
195 }
196
197 function copy_symlink() {
198         STACK=${2}
199         [ "${STACK}" = "" ] && STACK=16 || STACK=$((${STACK} - 1 ))
200
201         if [ ${STACK} -le 0 ] 
202         then
203                 echo "WARNING : ${TARGET} : too many levels of symbolic links !"
204                 return
205         fi
206
207         [ ! -e ${clst_root_path}/`dirname ${1}` ] && \
208                 mkdir -p ${clst_root_path}/`dirname ${1}`
209         [ ! -e ${clst_root_path}/${1} ] && \
210                 cp -vfdp ${1} ${clst_root_path}/${1}
211         
212         TARGET=`readlink -f ${1}`
213         if [ -h ${TARGET} ]
214         then
215                 copy_symlink ${TARGET} ${STACK}
216         else
217                 copy_file ${TARGET}
218         fi
219 }
220
221 function copy_file() {
222         f="${1}"
223
224         if [ ! -e "${f}" ]
225         then
226                 echo "WARNING : File not found : ${f}"
227                 continue
228         fi
229
230         [ ! -e ${clst_root_path}/`dirname ${f}` ] && \
231                 mkdir -p ${clst_root_path}/`dirname ${f}`
232         [ ! -e ${clst_root_path}/${f} ] && \
233                 cp -vfdp ${f} ${clst_root_path}/${f}
234         if [ -x ${f} -a ! -h ${f} ]
235         then
236                 copy_libs ${f}
237                 strip -R .comment -R .note ${clst_root_path}/${f} > /dev/null 2>&1
238         elif [ -h ${f} ]
239         then
240                 copy_symlink ${f}
241         fi
242 }